import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.ArrayList;

/**
 * 
 * Klasse Methodenbox für die Qualitätsbewertung des Mensaessens (Kapitel 1.4. Einstiegsaufgabe)
 * @author Peter Brichzin
 * @version 1.0
 */
public class Methodenbox 
{
    Text textBiosiegel;
    Text textRegional;
    Text textAussehen;
    Text textSchmecken;
    Text textEinseitig;

    Text textBiologischEmpfehlenswert;
    Text textGenussEmpfehlenswert;
    Text textVielseitigEmpfehlenswert;
    Text textRundumEmpfehlenswert;

    Text textAnleitung1;
    Text textAnleitung2;

    /**
     * 
     * Der Konstruktor meldet den Taktgeber
     * und die Eventlistener bei der Zeichenfläche an.
     *
     * Der Konstruktor legt die benötigten Objekte an und richtet sie ein.     
     */
    Methodenbox ()
    {
        Zeichenfenster.AktionsEmpfängerEintragen(new Zeichenfenster.AktionsEmpfaenger()
            {
                public void Ausführen ()
                {
                    TaktImpulsAusführen();
                }

                public void Taste (char taste)
                {
                    TasteGedrückt(taste);
                }

                public void SonderTaste (int taste)
                {
                    SonderTasteGedrückt(taste);
                }

                public void Geklickt (int x, int y, int anzahl)
                {
                    MausGeklickt(x, y, anzahl);
                }
            });

        textAnleitung1 = new Text("textAnleitung1");
        textAnleitung1.FarbeSetzen("grau"); 
        textAnleitung1.PositionSetzen(50, 50);
        textAnleitung1.TextGrößeSetzen(20);
        textAnleitung1.TextSetzen("Bitte durch Drücken der entsprechenden Tasten (t) Werte verändern.");

        textAnleitung2 = new Text("textAnleitung2");
        textAnleitung2.FarbeSetzen("grau"); 
        textAnleitung2.PositionSetzen(50, 75);
        textAnleitung2.TextGrößeSetzen(20);
        textAnleitung2.TextSetzen("Die Auswertung der Qualität erfolgt durch das Drücken der Taste q.");

        textBiosiegel = new Text("textBiosiegel");
        textBiosiegel.PositionSetzen(50, 150);
        textBiosiegel.TextGrößeSetzen(20);
        textBiosiegel.TextSetzen("(b) hatBiosiegel: " + "?");

        textRegional = new Text("textRegional");
        textRegional.PositionSetzen(50, 175);
        textRegional.TextGrößeSetzen(20);
        textRegional.TextSetzen("(r) istRegional: " + "?");

        textBiologischEmpfehlenswert = new Text("textBiologischEmpfehlenswert");
        textBiologischEmpfehlenswert.PositionSetzen(300, 175);
        textBiologischEmpfehlenswert.TextGrößeSetzen(20);
        textBiologischEmpfehlenswert.TextSetzen("istBiologischEmpfelenswert: " + "?");
        textBiologischEmpfehlenswert.FarbeSetzen("blau");

        textAussehen = new Text("textAussehen");
        textAussehen.PositionSetzen(50, 225);
        textAussehen.TextGrößeSetzen(20);
        textAussehen.TextSetzen("(a) istAussehenGut: " + "?");

        textSchmecken = new Text("textSchmecken");
        textSchmecken.PositionSetzen(50, 250);
        textSchmecken.TextGrößeSetzen(20);
        textSchmecken.TextSetzen("(s) schmecktGut: " + "?");

        textGenussEmpfehlenswert = new Text("textGenussEmpfehlenswert");
        textGenussEmpfehlenswert.PositionSetzen(300, 250);
        textGenussEmpfehlenswert.TextGrößeSetzen(20);
        textGenussEmpfehlenswert.TextSetzen("istGenussEmpfehlenswert: " + "?");
        textGenussEmpfehlenswert.FarbeSetzen("blau");

        textEinseitig = new Text("textEinseitig");
        textEinseitig.PositionSetzen(50, 300);
        textEinseitig.TextGrößeSetzen(20);
        textEinseitig.TextSetzen("(e) istEinseitig: " + "?");

        textVielseitigEmpfehlenswert = new Text("textVielseitigEmpfehlenswert");
        textVielseitigEmpfehlenswert.PositionSetzen(300, 300);
        textVielseitigEmpfehlenswert.TextGrößeSetzen(20);
        textVielseitigEmpfehlenswert.TextSetzen("istVielseitigEmpfehlenswert: " + "?");
        textVielseitigEmpfehlenswert.FarbeSetzen("blau");

        textRundumEmpfehlenswert = new Text("textRundumEmpfehlenswert");
        textRundumEmpfehlenswert.PositionSetzen(300, 350);
        textRundumEmpfehlenswert.TextGrößeSetzen(20);
        textRundumEmpfehlenswert.TextSetzen("istRundumEmpfehlenswert: " + "?");
        textRundumEmpfehlenswert.FarbeSetzen("grün");

    }

    /**
     * Die eigentliche Aktionsmethode des Zeitgebers.
     * <br>Muss bei Bedarf von einer Unterklasse überschrieben werden. 
     */
    void TaktImpulsAusführen ()
    {
        System.out.println ("Tick");
    }

    /**
     * Zeitgeber starten.
     */
    void Starten ()
    {
        Zeichenfenster.TaktgeberStarten();
    }

    /**
     * Zeitgeber anhalten.
     */
    void Anhalten ()
    {
        Zeichenfenster.TaktgeberStoppen();
    }

    /**
     * Ablaufgeschwindigkeit des Zeitgebers einstellen.
     * 
     * @param dauer: Angabe in Millisekunden
     */
    void TaktdauerSetzen (int dauer)
    {
        Zeichenfenster.TaktdauerSetzen(dauer);
    }

    /**
     * Die eigentliche Aktionsmethode für gedrückte Tasten.
     * <br>Muss bei Bedarf von einer Unterklasse überschrieben werden. 
     * @param taste die gedrückte Taste
     */
    void TasteGedrückt (char taste)
    {
        System. out. println ("Taste: " + taste);

    }

    /**
     * Die eigentliche Aktionsmethode für gedrückte Sondertasten.
     * <br>Muss bei Bedarf von einer Unterklasse überschrieben werden. 
     * @param taste KeyCode der gedrückten Taste
     */
    void SonderTasteGedrückt (int taste)
    {
        System. out. println ("Sondertaste: " + taste);
    }

    /**
     * Die eigentliche Aktionsmethode für einen Mausklick.
     * <br>Muss bei Bedarf von einer Unterklasse überschrieben werden. 
     * @param x x-Position des Mausklicks
     * @param y y-Position des Mausklicks
     * @param anzahl Anzahl der aufeinanderfolgenden Mausklicks
     */
    void MausGeklickt (int x, int y, int anzahl)
    {
        System. out. println ("Maus: (" + x + "|" + y + "), " + anzahl + " mal");
    }

    void setzeTextBiosiegel(String neuerText)
    {
        textBiosiegel.TextSetzen(neuerText);
    }

    void setzeTextRegional(String neuerText)
    {
        textRegional.TextSetzen(neuerText);
    }

    void setzeTextBiologischEmpfehlenswert(String neuerText)
    {
        textBiologischEmpfehlenswert.TextSetzen(neuerText);
    }

    void setzeTextAussehen(String neuerText)
    {
        textAussehen.TextSetzen(neuerText);
    }

    void setzeTextSchmecken(String neuerText)
    {
        textSchmecken.TextSetzen(neuerText);
    }

    void setzeTextGenussEmpfehlenswert(String neuerText)
    {
        textGenussEmpfehlenswert.TextSetzen(neuerText);
    }

    void setzeTextEinseitig(String neuerText)
    {
        textEinseitig.TextSetzen(neuerText);
    }

    void setzeTextVielseitigEmpfehlenswert(String neuerText)
    {
        textVielseitigEmpfehlenswert.TextSetzen(neuerText);
    }

    void setzeTextRundumEmpfehlenswert(String neuerText)
    {
        textRundumEmpfehlenswert.TextSetzen(neuerText);
    }

}

