import java.util.Scanner;
import java.util.Random;

/**
 * 
 * Klasse Methodenbox für Kapitel 1.4.4 Würfeln
 * @author Peter Brichzin
 * @version 1.0
 */

public class Methodenbox
{
    private Scanner scanner;
    Random zufall;
    
    /**
     * Konstruktor für Objekte der Klasse AlgoWrapper
     */
    public Methodenbox()
    {
       
       scanner = new Scanner(System.in);
       zufall = new Random();
    }

    public String liesWort()
    {
        return scanner.next();
    }

    public char liesBuchstaben()
    {
        return scanner.next().charAt(0);
    }
    
    /**
     * Methode ZufallszahlGeben
     *
     * @param von kleinster Wert der Zufallszahl 
     * @param bis größter Wert der Zufallszahl
     * @return Zufallszahl im Intervall [von, bis]
     */
    public int ZufallszahlGeben(int von, int bis)
    {
        return von + zufall.nextInt(bis+1-von);
    }
    
    /**
     * Methode warte, hält den Ablauf an
     *
     * @param Millisekunden Wartezeit in Millisekunden
     */
    void warte(int Millisekunden)
    {
        try {
            Thread.sleep(Millisekunden);
        } catch (InterruptedException e) {
            System.out.println("Thread is interrupted");
        }
    }
   
}

